//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.ApiFoyer {

    /** Permet d'ajouter un foyer */
    public enum PostApiFoyerAjouter {

        public static let service = APIService<Response>(id: "postApiFoyerAjouter", tag: "Api Foyer", method: "POST", path: "/apiFoyer/ajouter", hasBody: false)

        public final class Request: APIRequest<Response> {

            public struct Options {

                public var nom: String

                public var latitude: String

                public var longitude: String

                public var numeroTelephone: String

                public var rue: String

                public var codePostal: String

                public var commune: String

                public init(nom: String, latitude: String, longitude: String, numeroTelephone: String, rue: String, codePostal: String, commune: String) {
                    self.nom = nom
                    self.latitude = latitude
                    self.longitude = longitude
                    self.numeroTelephone = numeroTelephone
                    self.rue = rue
                    self.codePostal = codePostal
                    self.commune = commune
                }
            }

            public var options: Options

            public init(options: Options) {
                self.options = options
                super.init(service: PostApiFoyerAjouter.service)
            }

            /// convenience initialiser so an Option doesn't have to be created
            public convenience init(nom: String, latitude: String, longitude: String, numeroTelephone: String, rue: String, codePostal: String, commune: String) {
                let options = Options(nom: nom, latitude: latitude, longitude: longitude, numeroTelephone: numeroTelephone, rue: rue, codePostal: codePostal, commune: commune)
                self.init(options: options)
            }

            public override var parameters: [String: Any] {
                var params: JSONDictionary = [:]
                params["nom"] = options.nom
                params["latitude"] = options.latitude
                params["longitude"] = options.longitude
                params["numeroTelephone"] = options.numeroTelephone
                params["rue"] = options.rue
                params["codePostal"] = options.codePostal
                params["commune"] = options.commune
                return params
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = Credentials

            /** Succes */
            case status200(Credentials)

            public var success: Credentials? {
                switch self {
                case .status200(let response): return response
                }
            }

            public var response: Any {
                switch self {
                case .status200(let response): return response
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = try .status200(JSONDecoder.decode(data: data))
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
